<!DOCTYPE html>
<html lang="zxx">

 <head>
   <meta charset="utf-8">
   <title>MDEF Daphne Gerodimou</title>
   <meta name="viewport" content="width=device-width, initial-scale=1">
   <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

<!--link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css"-->
  <!-- Main Stylesheet -->
  <link href="../css/stylevol2.css" rel="stylesheet">

 </head>

 <body>

   <header>
    <div class="container">

       <nav class="nav">
         <lu class="nav lu">
           <li><a class="nav li" href="../index.html">HEY</a></li>
           <li> <a class="nav li" href="../FAB.html">BACK?</a></li>


           <hr>
         </lu>
       </nav>

     </div>
  </header>




<main>



       <div class="containerpost">


            <h2>0.8</h2>
            <br>
            <br><h3>EMBEDDED PROGRAMMING</b></h3>
            <br>

            <br> <h3><b>FACULTY :</b></h3>   FABLAB
            <br>
                 <h3><b>LOCATION :</b></h3>  IAAC
            <br>
            <br>
            <br>


                  <br>
                  <br>
                  <br>
              <h3><b>Blink blink that LED</b></h3>
              <br>
              <p>

                <br>

                <br



                    <img src="../images/fabacademy/arduino.jpg" alt="" class="imagespost">
                    <br>
             <br>

          For this assignment we do some basic output programming to our boards.
   <br>
   <br>
   <br>


             </p>

               <h3><b>DATASHEETS</b></h3>
               <br>
               <p>
                    <br>

      <b>Esp32-WROOM-32d</b>
        <br>
          <br>
      Ι primarly tried to avoid this part, but moving forward with arduino coding I realised it is rather important I understand even in a basic level what is going on with my boards.
      I started with the <b>Barduino / Esp32-Wroom-32d</b>. Even though I haven't managed to make my computer read the board I still wanted to understand how this beauty works especially
      because we will most likely use a node-MCU in the future.
      <br>
      Here is the link to the <a href="https://www.espressif.com/sites/default/files/documentation/esp32-wroom-32d_esp32-wroom-32u_datasheet_en.pdf" target="_blank">DATASHEET</a>
        <br>
        <br>

The basic principle I understood from going through the Datasheet was that according to your programming goals and expectations and especially the more complex those expectations become
it is extremely important to understand the capacities and limitations of the microcontroler as well as the correct pins to use for each specific application. First of all because you need to know the both the type of the pin you should use but also the pin-name that you should use for the code, so it corresponds to the actual pin you want.
  <br>
For example by reading the Datasheet I saw that  pins GPIO6 to GPIO11 are connected to the integrated SPI flash integrated on the module and are not recommended for other uses. Therefore, as I understood it it is important to avoid these pins when connecting sensors and peripheral devices to the board, as the Datasheet states that “External connections can be made to any GPIO except for GPIOs in the range 6-11.. These six GPIOs are connected to the module’s integrated SPI flash and will prevent the board from booting if you use them as inputs.
  <br>
<br>

<b>THINGS I DON'T UNDERSTAND</b>
<br>
<br>
  What exactly are the <b>strapping pins</b>, how they should be used and why are they important?
  <br>
  In the Datasheet the pins MTDI • GPIO0 • GPIO2 • MTDO • GPIO5 are characterised as strapping pins with the pull-up, pull-down aspect. Even though I understood
  through a bit of research what the internal pullup or pulldown
  (Internal pull-up means that it uses and input resistor to pull the pin high (on) and pull-down an input resistor to pull the pin low (of) I still don't understand
  how this exactly affects the coding or in case you would actually use those pins what functions should you implement in the coding to ensure a succesful result.
  <br>
 <br>

<b>ATMEGA328P-PU / Arduino Uno microcontroler</b>

<br>
<br>

  Then I decided to focus on the microcontroler that my ELEGO UNO R3 has which is simiral to the one an Arduino Uno has. Here is the link to the <a href="http://ww1.microchip.com/downloads/en/DeviceDoc/ATmega48A-PA-88A-PA-168A-PA-328-P-DS-DS40002061A.pdf" target="_blank">DATASHEET</a>
  <br>
    From this Datasheet, it was clear once again that according to the different applications you want to achieve  there are different types of digital and analog pins that dependent on your code or your project’s demands should be taken into consideration.
    Especially the more complex data you want to receive and the cleaner you want your input/ output data to be.
  <br>
    Actually this Datasheet was very long and very complex from me to retrieve valuable information. So instead I focused on reading the pinout diagram. One resourch that helped me a lot in understanding some of the differences of various pins and the different communication protocols of the board.
    is <a href="https://www.circuito.io/blog/arduino-uno-pinout/" target="_blank">Arduino Uno Pinout Guide</a>

  <br>
  <br>
  <br>
      <img src="../images/fabacademy/pinout.png" alt="" class="imagespost">
      <br>
      <br>
      <br>
      <b>Useful notes</b>
    <br>
    <br>
1. Not all analog and digital pins are the same. This might sound very basic but it was actually the fist time I explored their differences.
 <br>
 Pins 0 and 1 are the serial pins (TTL) that allow for the serial communication of the board with the computer.
So from what I understand, although I might be wrong, is that it is better to avoid these pins for general coding.
<br>
Pin 13 is connected to a LED . That one can figure from looking at the board, but also it is a pin has less capabilies for digital read and write.
<br>
Pins 3,5,6,9,10,11 have PWM capability.
<br>
Which are better used for speed controls and dimming leds because as I understand it they are better for “fake analog” output {analog write}
when for example we want to control gradually the speed of the motor or control or fade an LED without just turning it on and off.
 <br>
2.The analog inputs can also be used as digital inputs/ outputs.
 <br>
3.For working with sensors what I understand is that each sensor might require or at least work better with  a different pin either that is a 12c pin or a
  SPI pin. And that is why it is important to know exactly each pin’s capabilities.

  <br>
  <br>

<b>THINGS I DON'T UNDERSTAND</b>
<br>
What I don’t understand is the extra characteristics of the analog pins 4 and 5, especially the serial interface clock line. What is special about those pins and in which case is it better to use them?
As an abstract notion I got is that they should be used when we are dealing with more certain sensors but I don't understand the specifics of this.
 <br>
 Obviously, there are also other things I don't completely understand as the specifics of each communication protocol but I guess it is knowledge that comes also with experience.


</p>
<br>
<br>
<br>
  <h3><b>EXAMPLES</b></h3>
  <br>
  <p>







    <br>
     <br>

             Even though I have my Barduino as I stated before, I struggled with installing the drivers in my computer. So I decided to use my arduino for this
             assignment while I figure out how to make my computer capable of reading my board.

              <br>
               <br>
               Since I am not at all experienced with arduino coding I started by doing the most simple example which is the blink one
               just to start getting confidednt and gradually working with more complex codes and electronic setups.
               <br>
               <br>
               All the circuits I used for these examples have the same basic diagram. A led with its positive leg (the long one) connected to a resistor which is connected to the pin I am using on the Arduino and another cable which connects the other leg of the Led to the ground (GND) of the board.
               <br>
               Of course in the case of the 3 Leds we need 3 resistors in a similar logic.
               <br>
               <br>
               <br>
                <img src="../images/fabacademy/ledsetup.png" alt="" class="imagespost">
               <br>
               <br>
               <br>
               So I started with one LED
               <br>
               <br>
               <br>
               <video class="videopost" controls muted width="768" height="432" controls>
            <source src="../images/fabacademy/blink.mp4" type="video/mp4" autostart="false" />
            </video>

            <br>
            <br>
            <br>
              <img src="../images/fabacademy/blink.png" alt="" class="imagespost">
            <br>
            <br>
            This code is the simplest coding for a LED blink. I used the pin 8 as the output pin. The Led blinks in a loop with one second delay.
            <br>
            I used a 220ohm resistor.
            <br>
            <br>
            <br>
          Then  I added two more LEDS in order to make a sequential blinking of RGB colour LEDS. I used 3 220ohm resistors.

            <br>
            <br>
            <br>
            <video class="videopost" controls muted width="768" height="432" controls>
         <source src="../images/fabacademy/seqblink.mp4" type="video/mp4" autostart="false" />
         </video>
         <br>
         <br>
         <br>
           <img src="../images/fabacademy/seqblink.png" alt="" class="imagespost">
         <br>
         <br>
         The code is also very simple. It uses 3 output pins, pin 13, 12 and 11. It has a 1000ms delay between setting of the LEDs and a 300ms delay in turning them off.
         Then it has a also a 300ms delay for the loop setup.
         <br>
         <br>
         <br>

         <br>
             <img src="../images/fabacademy/rgb.jpeg" alt="" class="">

             <br>
             <br>
              <br>

          <b>BLINK WITOUT DELAY</b>
               <br>
               <br>
               <br>

            This code uses another function called <b>millis</b> in or to replace the delay function which can be restricting  if you want to fo more than one functions at once.  Delay pauses the whole code which can affect other actions running simultaneously like for example pushing or button.
               <br>
            This command basically returns the number of milliseconds since the board started running its current sketch, to blink an LED.
              <br>
            I used the pin 3 as my digital output pin. With the <b>const long interval</b> you can control the time of the led's blinking.

            <br>
            <br>
             <br>
                <img src="../images/fabacademy/withoutdelay.png" alt="" class="imagespost">

             <br>
             <br>
              <br>
              <br>
              <br>
              <br>
              <video class="videopost" controls muted width="768" height="432" controls>
           <source src="../images/fabacademy/withoutdelay.mp4" type="video/mp4" autostart="false" />
           </video>
           <br>
           <br>
          <br>
          <b> FADE </b>
          <br>
          <br>
         <br>
              Then I decided to try to Fade one LED. I used the digital pin 3 because as I found out in the pinout/ datasheet research it is one of the pins
              that have the PWM value.
              <br>
              <br>
              <br>
                <img src="../images/fabacademy/fade.png" alt="" class="imagespost">
              <br>
              <br>
              <br>

              What this code does is that it uses the analog write function to create a fake analog that it is not just Low or high.
                <br>
              In order to fade your LED off and on, gradually increase your PWM value from 0 (all the way off) to 255 (all the way on),
              and then back to 0 once again to complete the cycle.  That is why it is necessary to use the digital pins with the PMW value.
  <br>
  brightness = brightness + fadeAmount;
  <br>

  if (brightness <= 0 || brightness >= 255) {
    fadeAmount = -fadeAmount;
  <br>

The variable brightness defines the PMW value. The function above allows for the brigthness value to change direction which gives the fade in fade out effect.
 <br>
 I tried changing the fadeAmmount value to see how the Led will behave and I noticed that beneat the value 3 the fade cannot be reversed. With a the double value of 10 the fade was not that
 smooth.
 <br>
 <br>
Here is a link of <a href="https://www.arduino.cc/en/tutorial/fade" target="_blank">Arduino Tutorial on Fade</a> that helped me undestand better how this code works. 
 <br>
 <video class="videopost" controls muted width="768" height="432" controls>
<source src="../images/fabacademy/fade.mp4" type="video/mp4" autostart="false" />
</video>
<br>
<br>
<br>


<h3><b>FILES</b></h3>
<br>
<br>
                           <p>

                             <a href="../files/blink.ino"> Blink <a/>
                                  <br>

                              <a href="../files/Sequential_blinking.ino">Sequentialblinking<a/>
                                  <br>
                              <a href="../files/blinkwithoutdelay.ino">Blink without delay<a/>
                                      <br>
                            <a href="../files/Fade.ino">Fade<a/>
                                              <br>




                       </p>
                       <br>















</main>

</body>











<!-- Navigation Start -->
<!-- Header Start -->





















<!-- Footer End -->

<!-- jQuery -->
<script src="plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="plugins/bootstrap/bootstrap.min.js"></script>
<script src="plugins/aos/aos.js"></script>
<script src="plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="plugins/shuffle/shuffle.min.js"></script>
<script src="plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="plugins/animated-text/animated-text.js"></script>
<script src="plugins/counto/apear.js"></script>
<script src="plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="plugins/google-map/map.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAkeLMlsiwzp6b3Gnaxd86lvakimwGA6UA&callback=initMap"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
